# Sass

![Lifecycle](https://img.shields.io/badge/lifecycle-stable-green.svg)
[![CI](https://github.com/piever/Sass.jl/workflows/CI/badge.svg?branch=master)](https://github.com/piever/Sass.jl/actions?query=workflow%3ACI+branch%3Amaster)
[![codecov.io](http://codecov.io/github/piever/Sass.jl/coverage.svg?branch=master)](http://codecov.io/github/piever/Sass.jl?branch=master)

## Compile scss and sass file to css in Julia

This library provides a simple Julian API to use the libsass library to compile scss and sass files to css.

```julia
using Sass
filename = joinpath(Sass.examplefolder, "test.sass")
Sass.compile_file(filename; precision = 1, source_comments = true)
```

To write the output to a file use the signature:

```julia
Sass.compile_file(filename, dest; kwargs...)
```

## List of keyword arguments

All libsass options can be passed as keyword arguments:

- `output_style`: output style for the generated css code. See `Sass.Style` for options. For example `output_style  = Sass.nested`
- `source_comments`: a boolean to specify whether to insert inline source comments
- `source_map_file`: path to source map file, enables the source map generating used to create sourceMappingUrl
- `omit_source_map_url`: disable sourceMappingUrl in css output
- `source_map_embed`: embed sourceMappingUrl as data uri
- `source_map_contents`: embed include contents in maps
- `source_map_file_urls`: create file urls for sources
- `source_map_root`: pass-through as sourceRoot property
- `is_indented_syntax_src`: treat source_string as sass (as opposed to scss)
- `include_path` (`AbstractString` or `AbstractArray{<:AbstractString}`)
- `plugin_path` (`AbstractString` or `AbstractArray{<:AbstractString}`)
- `indent`: string to be used for indentation
- `linefeed`: string to be used to for line feeds
- `input_path`: the input path is used for source map generating. It can be used to define something with string compilation or to overload the input file path. It is set to `stdin` for data contexts and to the input file on file contexts.
- `output_path`: the output path is used for source map generating. LibSass will not write to this file, it is just used to create information in source-maps etc.
- `precision`: precision for outputting fractional numbers

## Using the libsass API

For more advanced use, the main functions of the libsass API are ported and can be used directly for a finer control. This is more complicated and should be unnecessary in most cases.

### Example (from libsass docs): building a file compiler

```julia
using Sass
filename = joinpath(Sass.examplefolder, "test.sass")
context = sass_make_file_context(filename)
options = sass_file_context_get_options(context)
sass_option_set_precision(options, 1)
sass_option_set_source_comments(options, true)

sass_file_context_set_options(context, options)

compiler = sass_make_file_compiler(context)
sass_compiler_parse(compiler)
sass_compiler_execute(compiler)

output = sass_context_get_output_string(context)
# Retrieve errors during compilation
error_status = sass_context_get_error_status(context)
json_error = sass_context_get_error_json(context)
# Release memory dedicated to the C compiler
sass_delete_compiler(compiler)
```

using Sass
using Test

filename = joinpath(Sass.examplefolder, "test.sass")

@testset "outputstyle" begin
    css = Sass.compile_file(filename; output_style = Sass.nested)
    @test css == "body {\n  font: 100% Helvetica, sans-serif;\n  color: #333; }\n"
    css = Sass.compile_file(filename; output_style = Sass.expanded)
    @test css == "body {\n  font: 100% Helvetica, sans-serif;\n  color: #333;\n}\n"
    css = Sass.compile_file(filename; output_style = Sass.compact)
    @test css == "body { font: 100% Helvetica, sans-serif; color: #333; }\n"
    css = Sass.compile_file(filename; output_style = Sass.compressed)
    @test css == "body{font:100% Helvetica,sans-serif;color:#333}\n"
end

export sass_make_file_compiler
export sass_make_data_compiler
export sass_compiler_parse
export sass_compiler_execute
export sass_delete_compiler

function sass_make_file_compiler(sass_context)
    ccall((:sass_make_file_compiler, libsass_so),
        Ptr{Cvoid}, (Ptr{Cvoid},), sass_context)
end

function sass_make_data_compiler(sass_context)
    ccall((:sass_make_data_compiler, libsass_so),
        Ptr{Cvoid}, (Ptr{Cvoid},), sass_context)
end

function sass_compiler_parse(compiler)
    ccall((:sass_compiler_parse, libsass_so),
        Cvoid, (Ptr{Cvoid},), compiler)
end

function sass_compiler_execute(compiler)
    ccall((:sass_compiler_execute, libsass_so),
        Cvoid, (Ptr{Cvoid},), compiler)
end

function sass_delete_compiler(compiler)
    ccall((:sass_delete_compiler, libsass_so),
        Cvoid, (Ptr{Cvoid},), compiler)
end

export sass_option_get_output_style, sass_option_set_output_style
export sass_option_get_source_comments, sass_option_set_source_comments
export sass_option_get_source_map_file, sass_option_set_source_map_file
export sass_option_get_omit_source_map_url, sass_option_set_omit_source_map_url
export sass_option_get_source_map_embed, sass_option_set_source_map_embed
export sass_option_get_source_map_contents, sass_option_set_source_map_contents
export sass_option_get_source_map_file_urls, sass_option_set_source_map_file_urls
export sass_option_get_source_map_root, sass_option_set_source_map_root
export sass_option_get_is_indented_syntax_src, sass_option_set_is_indented_syntax_src
export sass_option_get_include_path, sass_option_set_include_path
export sass_option_get_plugin_path, sass_option_set_plugin_path
export sass_option_get_indent, sass_option_set_indent
export sass_option_get_linefeed, sass_option_set_linefeed
export sass_option_get_input_path, sass_option_set_input_path
export sass_option_get_output_path, sass_option_set_output_path
export sass_option_get_precision, sass_option_set_precision

@enum Style nested expanded compact compressed

function sass_option_get_output_style(options)
    i = ccall((:sass_option_get_output_style, libsass_so),
        Cint, (Ptr{Cvoid},), options)
    Style(i)
end

sass_option_set_output_style(options, output_style::Style) =
    sass_option_set_output_style(options, Int(output_style))

function sass_option_set_output_style(options, output_style::Integer)
    ccall((:sass_option_set_output_style, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cint), options, output_style)
end

function sass_option_get_source_comments(options)
    ccall((:sass_option_get_source_comments, libsass_so),
        Cint, (Ptr{Cvoid},), options)
end

function sass_option_set_source_comments(options, source_comments)
    ccall((:sass_option_set_source_comments, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cint), options, source_comments)
end

function sass_option_get_source_map_file(options)
    s = ccall((:sass_option_get_source_map_file, libsass_so),
        Cstring, (Ptr{Cvoid},), options)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_option_set_source_map_file(options, map_file)
    ccall((:sass_option_set_source_map_file, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cstring), options, map_file)
end

function sass_option_get_omit_source_map_url(options)
    ccall((:sass_option_get_omit_source_map_url, libsass_so),
        Cint, (Ptr{Cvoid},), options)
end

function sass_option_set_omit_source_map_url(options, omit_source_map_url)
    ccall((:sass_option_set_omit_source_map_url, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cint), options, omit_source_map_url)
end

function sass_option_get_source_map_embed(options)
    ccall((:sass_option_get_source_map_embed, libsass_so),
        Cint, (Ptr{Cvoid},), options)
end

function sass_option_set_source_map_embed(options, source_map_embed)
    ccall((:sass_option_set_source_map_embed, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cint), options, source_map_embed)
end

function sass_option_get_source_map_contents(options)
    ccall((:sass_option_get_source_map_contents, libsass_so),
        Cint, (Ptr{Cvoid},), options)
end

function sass_option_set_source_map_contents(options, source_map_contents)
    ccall((:sass_option_set_source_map_contents, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cint), options, source_map_contents)
end

function sass_option_get_source_map_file_urls(options)
    ccall((:sass_option_get_source_map_file_urls, libsass_so),
        Cint, (Ptr{Cvoid},), options)
end

function sass_option_set_source_map_file_urls(options, source_map_file_urls)
    ccall((:sass_option_set_source_map_file_urls, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cint), options, source_map_file_urls)
end

function sass_option_get_source_map_root(options)
    s = ccall((:sass_option_get_source_map_root, libsass_so),
        Cstring, (Ptr{Cvoid},), options)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_option_set_source_map_root(options, source_map_root)
    ccall((:sass_option_set_source_map_root, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cstring), options, source_map_root)
end

function sass_option_get_is_indented_syntax_src(options)
    ccall((:sass_option_get_is_indented_syntax_src, libsass_so),
        Cint, (Ptr{Cvoid},), options)
end

function sass_option_set_is_indented_syntax_src(options, is_indented_syntax_src)
    ccall((:sass_option_set_is_indented_syntax_src, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cint), options, is_indented_syntax_src)
end

function sass_option_get_include_path(options)
    s = ccall((:sass_option_get_include_path, libsass_so),
        Cstring, (Ptr{Cvoid},), options)
    s == C_NULL && return nothing
    julia_pathlist(unsafe_string(s))
end

function sass_option_set_include_path(options, include_path)
    ccall((:sass_option_set_include_path, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cstring), options, c_pathlist(include_path))
end

function sass_option_get_plugin_path(options)
    s = ccall((:sass_option_get_plugin_path, libsass_so),
        Cstring, (Ptr{Cvoid},), options)
    s == C_NULL && return nothing
    julia_pathlist(unsafe_string(s))
end

function sass_option_set_plugin_path(options, plugin_path)
    ccall((:sass_option_set_plugin_path, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cstring), options, c_pathlist(plugin_path))
end

function sass_option_get_indent(options)
    s = ccall((:sass_option_get_indent, libsass_so),
        Cstring, (Ptr{Cvoid},), options)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_option_set_indent(options, indent)
    ccall((:sass_option_set_indent, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cstring), options, indent)
end

function sass_option_get_linefeed(options)
    s = ccall((:sass_option_get_linefeed, libsass_so),
        Cstring, (Ptr{Cvoid},), options)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_option_set_linefeed(options, linefeed)
    ccall((:sass_option_set_linefeed, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cstring), options, linefeed)
end

function sass_option_get_input_path(options)
    s = ccall((:sass_option_get_input_path, libsass_so),
        Cstring, (Ptr{Cvoid},), options)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_option_set_input_path(options, input_path)
    ccall((:sass_option_set_input_path, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cstring), options, input_path)
end

function sass_option_get_output_path(options)
    s = ccall((:sass_option_get_output_path, libsass_so),
        Cstring, (Ptr{Cvoid},), options)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_option_set_output_path(options, output_path)
    ccall((:sass_option_set_output_path, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cstring), options, output_path)
end

function sass_option_get_precision(options)
    ccall((:sass_option_get_precision, libsass_so),
        Cint, (Ptr{Cvoid},), options)
end

function sass_option_set_precision(options, precision)
    ccall((:sass_option_set_precision, libsass_so),
        Cvoid, (Ptr{Cvoid}, Cint), options, precision)
end

const separator = Sys.iswindows() ? ';' : ':'

c_pathlist(s::AbstractString) = s
c_pathlist(s) = join(s, separator)

julia_pathlist(s) = split(s, separator)

using Documenter, Sass

makedocs(
    modules = [Sass],
    format = :html,
    sitename = "Sass.jl",
    pages = Any["index.md"]
)

deploydocs(
    repo = "github.com/piever/Sass.jl.git",
    target = "build",
    julia = "1.0",
    deps = nothing,
    make = nothing,
)

const attributes_setters = Dict(
    :output_style => sass_option_set_output_style,
    :source_comments => sass_option_set_source_comments,
    :source_map_file => sass_option_set_source_map_file,
    :omit_source_map_url => sass_option_set_omit_source_map_url,
    :source_map_embed => sass_option_set_source_map_embed,
    :source_map_contents => sass_option_set_source_map_contents,
    :source_map_file_urls => sass_option_set_source_map_file_urls,
    :source_map_root => sass_option_set_source_map_root,
    :is_indented_syntax_src => sass_option_set_is_indented_syntax_src,
    :include_path => sass_option_set_include_path,
    :plugin_path => sass_option_set_plugin_path,
    :indent => sass_option_set_indent,
    :linefeed => sass_option_set_linefeed,
    :input_path => sass_option_set_input_path,
    :output_path => sass_option_set_output_path,
    :precision => sass_option_set_precision,
)

"""
`compile_file(filename; kwargs...)`

Compile `filename` from sass or scss to a css string. Possible options, given by keyword
arguments, are:

- `output_style`: output style for the generated css code. See `Sass.Style` for options. For example `output_style  = Sass.nested`
- `source_comments`: a boolean to specify whether to insert inline source comments
- `source_map_file`: path to source map file, enables the source map generating used to create sourceMappingUrl
- `omit_source_map_url`: disable sourceMappingUrl in css output
- `source_map_embed`: embed sourceMappingUrl as data uri
- `source_map_contents`: embed include contents in maps
- `source_map_file_urls`: create file urls for sources
- `source_map_root`: pass-through as sourceRoot property
- `is_indented_syntax_src`: treat source_string as sass (as opposed to scss)
- `include_path` (`AbstractString` or `AbstractArray{<:AbstractString}`)
- `plugin_path` (`AbstractString` or `AbstractArray{<:AbstractString}`)
- `indent`: string to be used for indentation
- `linefeed`: string to be used to for line feeds
- `input_path`: the input path is used for source map generating. It can be used to define something with string compilation or to overload the input file path. It is set to `stdin` for data contexts and to the input file on file contexts.
- `output_path`: the output path is used for source map generating. LibSass will not write to this file, it is just used to create information in source-maps etc.
- `precision`: precision for outputting fractional numbers

## Examples

```julia
julia> filename = joinpath(Sass.examplefolder, "test.sass");

julia> Sass.compile_file(filename; output_style = Sass.compressed)
"body{font:100% Helvetica,sans-serif;color:#333}\n"
```
"""
function compile_file(filename; input_path = filename, source_map_file = nothing, kwargs...)
    ctx = sass_make_file_context(filename)
    ctx_out = sass_file_context_get_context(ctx)
    options = sass_context_get_options(ctx)
    for (key, val) in kwargs
        setter = get(attributes_setters, key, nothing)
        setter === nothing || setter(options, val)
    end
    sass_option_set_input_path(options, input_path)
    source_map_file === nothing || sass_option_set_source_map_file(options, source_map_file)

    sass_file_context_set_options(ctx, options)

    sass_compile_file_context(ctx)

    status = sass_context_get_error_status(ctx_out)

    status == 0 || error(sass_context_get_error_text(ctx_out))

    css =  sass_context_get_output_string(ctx_out)
    ret = source_map_file === nothing ? css : (css, sass_context_get_source_map_string(ctx_out))

    sass_delete_file_context(ctx)
    ret
end

"""
`compile_file(filename, dest; kwargs...)`

Same as `compile_file(filename; kwargs)` but writes the resulting string in file `dest`.
"""
function compile_file(filename, dest; output_path = dest, source_map_file = nothing, kwargs...)
    if source_map_file === nothing
        css = compile_file(filename; output_path = output_path, kwargs...)
        open(dest, "w") do io
             write(io, css)
         end
    else
        css, src_map = compile_file(filename; output_path = output_path, source_map_file = source_map_file, kwargs...)
        open(dest, "w") do io
            write(io, css)
        end
        open(source_map_file, "w") do io
            write(io, src_map)
        end
    end
 end

module Sass

using libsass_jll

include("version.jl")
include("context.jl")
include("options.jl")
include("compiler.jl")
include("julian_api.jl")

examplefolder = normpath(joinpath(@__DIR__, "..", "test", "css"))

end # module

export sass_make_file_context, sass_delete_file_context, sass_compile_file_context
export sass_file_context_get_context, sass_file_context_get_options, sass_file_context_set_options
export sass_make_data_context, sass_delete_data_context, sass_compile_data_context
export sass_data_context_get_context, sass_data_context_get_options, sass_data_context_set_options
export sass_context_get_options, sass_context_set_options
export sass_context_get_output_string
export sass_context_get_source_map_string
export sass_context_get_error_status
export sass_context_get_error_json
export sass_context_get_error_text
export sass_context_get_error_message

# File

function sass_make_file_context(filename)
    ccall((:sass_make_file_context, libsass_so),
        Ptr{Cvoid}, (Cstring,), filename)
end

function sass_delete_file_context(context)
    ccall((:sass_delete_file_context, libsass_so),
        Cvoid, (Ptr{Cvoid},), context)
end

function sass_compile_file_context(context)
    ccall((:sass_compile_file_context, libsass_so),
        Cint, (Ptr{Cvoid},), context)
end

function sass_file_context_get_context(context)
    ccall((:sass_file_context_get_context, libsass_so),
        Ptr{Cvoid}, (Ptr{Cvoid},), context)
end

function sass_file_context_get_options(context)
    ccall((:sass_file_context_get_options, libsass_so),
        Ptr{Cvoid}, (Ptr{Cvoid},), context)
end

function sass_file_context_set_options(context, options)
    ccall((:sass_file_context_get_options, libsass_so),
        Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), context, options)
end

# Data

function sass_make_data_context(data)
    ccall((:sass_make_data_context, libsass_so),
        Ptr{Cvoid}, (Ptr{UInt8},), data)
end

function sass_delete_data_context(context)
    ccall((:sass_delete_data_context, libsass_so),
        Cvoid, (Ptr{Cvoid},), context)
end

function sass_compile_data_context(context)
    ccall((:sass_compile_data_context, libsass_so),
        Cint, (Ptr{Cvoid},), context)
end

function sass_data_context_get_context(context)
    ccall((:sass_data_context_get_context, libsass_so),
        Ptr{Cvoid}, (Ptr{Cvoid},), context)
end

function sass_data_context_get_options(context)
    ccall((:sass_data_context_get_options, libsass_so),
        Ptr{Cvoid}, (Ptr{Cvoid},), context)
end

function sass_data_context_set_options(context, options)
    ccall((:sass_data_context_get_options, libsass_so),
        Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), context, options)
end

# Context

function sass_context_get_options(context)
    ccall((:sass_context_get_options, libsass_so),
        Ptr{Cvoid}, (Ptr{Cvoid},), context)
end

function sass_context_set_options(context, options)
    ccall((:sass_context_get_options, libsass_so),
        Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), context, options)
end

function sass_context_get_output_string(context)
    s = ccall((:sass_context_get_output_string, libsass_so),
        Cstring, (Ptr{Cvoid},), context)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_context_get_source_map_string(context)
    s = ccall((:sass_context_get_source_map_string, libsass_so),
        Cstring, (Ptr{Cvoid},), context)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_context_get_error_status(context)
    ccall((:sass_context_get_error_status, libsass_so),
        Cint, (Ptr{Cvoid},), context)
end

function sass_context_get_error_json(context)
    s = ccall((:sass_context_get_error_json, libsass_so),
        Cstring, (Ptr{Cvoid},), context)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_context_get_error_text(context)
    s = ccall((:sass_context_get_error_text, libsass_so),
        Cstring, (Ptr{Cvoid},), context)
    s == C_NULL ? nothing : unsafe_string(s)
end

function sass_context_get_error_message(context)
    s = ccall((:sass_context_get_error_message, libsass_so),
        Cstring, (Ptr{Cvoid},), context)
    s == C_NULL ? nothing : unsafe_string(s)
end
